]> diplodocus.org Git - nmh/blob - test/common.sh.in
Added context_find_prefix().
[nmh] / test / common.sh.in
1 # Common helper routines for test shell scripts -- to be sourced by them
2 # @configure_input@
3
4
5 #### The following variables are set by "make check". Ensure
6 #### that they are set here so that individual tests can be run
7 #### outside of make. Requires that MH_OBJ_DIR be set on entry.
8 test -z "$MH_TEST_DIR" && MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
9 test -z "$MH_INST_DIR" && MH_INST_DIR="${MH_TEST_DIR}/inst"
10 test -z "$prefix" && prefix=@prefix@
11 test -z "$datarootdir" && datarootdir=@datarootdir@
12 test -z "$exec_prefix" && exec_prefix=@exec_prefix@
13 test -z "$bindir" && bindir="@bindir@"
14 test -z "$mandir" && mandir="@mandir@"
15 test -z "$nmhetcdir" && nmhetcdir="@sysconfdir@/nmh"
16 #### The following doesn't support running the distcheck version of
17 #### test-mhparam standalone, but only via make distcheck.
18 test -z "$nmhetcdirinst" && nmhetcdirinst="@nmhetcdirinst@$nmhetcdir"
19 test -z "$nmhlibexecdir" && nmhlibexecdir="@libexecdir@/nmh"
20 test -z "$supported_locks" && supported_locks="@supported_locks@"
21 test -z "$default_locking" && default_locking="@default_locking@"
22 test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED="@MULTIBYTE_ENABLED@"
23 test -z "$ICONV_ENABLED" && ICONV_ENABLED="@ICONV_ENABLED@"
24
25 unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
26 unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
27 #### Set LC_ALL in individual tests as needed. Unset these so
28 #### that we don't depend on user's settings in other tests.
29 unset LANG LC_ALL LC_CTYPE
30
31 #### Use a test dir for tmp files when MHTMPDIR applies.
32 MHTMPDIR=$MH_TEST_DIR/Mail
33 export MHTMPDIR
34
35 #### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
36 #### the test suite from cleaning up the results of a test run, if you need
37 #### to do manual debugging on a test.
38
39 output_md5()
40 {
41 #### Output just the checksum. If the filename needs to appear on
42 #### the same line, the caller needs to add it. This avoids
43 #### differences due to a leading '*' binary file indicator, for
44 #### text files, on some platforms (Cygwin).
45 @MD5SUM@ $* | @MD5FMT@ | awk '{print $1}'
46 }
47
48 #### Use built-in $((...)) in test suite if shell supports it.
49 #### Borrowed from configure's as_fn_arith. The result is placed
50 #### in global arith_val.
51 #### Detected at run-time instead of by configure to allow testing
52 #### with different shells.
53 if (eval "test \$(( 1 + 1 )) = 2" 2>/dev/null); then
54 eval 'arith_eval () { arith_val=$(( $* )); }'
55 else
56 arith_eval () { arith_val=`expr "$@" || test $? -eq 1`; }
57 fi
58
59 test_skip ()
60 {
61 WHY="$1"
62 echo "$Test $0 SKIP ($WHY)"
63 exit 77
64 }
65
66 # portable implementation of 'which' utility
67 findprog()
68 {
69 PROG="$1"
70 #### Don't need to save current IFS because this function is run in
71 #### a subshell.
72 IFS=:
73 for D in $PATH; do
74 if [ -z "$D" ]; then
75 D=.
76 fi
77 if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
78 printf '%s\n' "$D/$PROG"
79 break
80 fi
81 done
82 }
83
84 require_prog ()
85 {
86 if [ -z "`findprog $1`" ]; then
87 test_skip "missing $1"
88 fi
89 }
90
91 # Skip test if none of the offered locales are supported.
92 require_locale ()
93 {
94 for locale in "$@"; do
95 if locale -a | grep -i "$locale" >/dev/null; then
96 return
97 fi
98 done
99
100 test_skip "no suitable locale available"
101 }
102
103 # Some stuff for doing silly progress indicators
104 if [ -t 1 ] ; then
105 progress_update ()
106 {
107 THIS="$1"
108 FIRST="$2"
109 LAST="$3"
110 arith_eval $LAST - $FIRST; RANGE=$arith_val
111 arith_eval $THIS - $FIRST; PROG=$arith_val
112 # this automatically rounds to nearest integer
113 arith_eval 100 \* $PROG / $RANGE; PERC=$arith_val
114 # note \r so next update will overwrite
115 printf '%3d%%\r' $PERC
116 }
117
118 progress_done ()
119 {
120 printf '100%%\n'
121 }
122 else
123 # don't emit anything if stdout is not connected to a tty.
124 progress_update ()
125 {
126 :
127 }
128 progress_done ()
129 {
130 :
131 }
132 fi
133
134 check_for_hard_links () {
135 set +e
136
137 printf '' > "${MH_TEST_DIR}/$$-1"
138 xdir_links_supported=0
139 if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
140 hard_links_supported=1
141 mkdir "${MH_TEST_DIR}/xlinkdir"
142 if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev/null; then
143 xdir_links_supported=1
144 fi
145 else
146 hard_links_supported=0
147 fi
148 rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
149 rm -rf "${MH_TEST_DIR}/xlinkdir"
150
151 set -e
152 }
153
154 #### Filter that squeezes blank lines, partially emulating GNU cat -s,
155 #### but sufficient for our purpose.
156 #### From http://www-rohan.sdsu.edu/doc/sed.html, compiled by Eric Pement.
157 squeeze_lines() {
158 sed '/^$/N;/\n$/D'
159 }
160
161 #### Filter that converts non-breakable space U+00A0 to an ASCII space.
162 prepare_space() {
163 sed 's/'"`printf '\\302\\240'`"'/ /g'
164 }
165
166 #### check() requires two arguments, each the name of a file to be
167 #### diff'ed.
168 #### If the contents are same, the second file is removed. If different,
169 #### global variable "failed" is incremented.
170 #### Optional arguments:
171 #### 'keep first' -- first file is removed unless this is present.
172 #### 'ignore space' -- spacing differences will not be considered
173 #### significant, emulating GNU diff -w. It is assumed that the
174 #### first file has already been run through prepare_space.
175 #### ':' <test name> -- will print '<test name>' in the failure message,
176 #### to make it easier to tell which of multiple tests has failed.
177 check() {
178 first=$1; shift
179 second=$1; shift
180 keepfirst=
181 ignorespace=
182 label=test
183 while [ $# -gt 0 ]; do
184 case $1 in
185 'keep first') keepfirst=1 ;;
186 'ignore space') ignorespace=1 ;;
187 ':') shift; label=\'"$*"\'; break ;;
188 *) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
189 esac
190 shift
191 done
192
193 success=
194 if [ "$ignorespace" ]; then
195 #### POSIX diff should support -b.
196 prepare_space <"$second" | diff -b "$first" - >/dev/null && success=1
197 else
198 cmp -s "$first" "$second" && success=1
199 fi
200
201 if [ "$success" ]; then
202 [ "$keepfirst" ] || rm -f "$first"
203 rm -f "$second"
204 else
205 echo
206 #### POSIX diff should support -c.
207 diff -c "$first" "$second" || true
208 echo
209 echo "$0: $label failed, outputs are in $first and $second."
210 failed=`expr ${failed:-0} + 1`
211 #### Set return status of the function.
212 [ $failed -eq 0 ]
213 fi
214 }
215
216
217 #### Shortcut to enable use of valgrind: set NMH_VALGRIND environment
218 #### variable (to anything) so run_* will use valgrind.
219 if [ "${NMH_VALGRIND}" -a -z "${NMH_TEST_PREFIX}" ]; then
220 #### Need absolute path to valgrind.supp in case the test does a cd.
221 NMH_TEST_PREFIX="valgrind --quiet --error-exitcode=1 \
222 --suppressions=`cd ${srcdir} && pwd`/test/valgrind.supp"
223 fi
224
225 #### Run test under another program by setting NMH_TEST_PREFIX
226 #### environment variable to, e.g., 'valgrind --quiet'.
227 run_prog() {
228 case $1 in
229 #### Don't run valgrind on shell built-in.
230 eval\ *) "$@" ;;
231 *) ${NMH_TEST_PREFIX} "$@" ;;
232 esac
233 }
234
235
236 #### run_test() requires two arguments, the first is a program and
237 #### arguments, the second is its expected one-line output string.
238 #### If the actual output does not match that string:
239 #### an error message is printed and global variable "failed" is incremented;
240 #### if there is an optional third argument, it is used in the error message.
241 run_test() {
242 set +e
243 case $1 in
244 #### Don't run valgrind on shell built-in.
245 eval\ *) actual_output=`$1 2>&1` ;;
246 *) actual_output=`${NMH_TEST_PREFIX} $1 2>&1` ;;
247 esac
248 set -e
249 if test x"$actual_output" != x"$2"; then
250 echo "$0: ${3:-\"$1\"} expected:" 1>&2
251 echo " '$2'" 1>&2
252 echo "but instead got:" 1>&2
253 echo " '$actual_output'" 1>&2
254 failed=`expr ${failed:-0} + 1`
255 fi
256 }
257
258 #### Function invoked by trap on exit.
259 cleanup() {
260 #### Save exit status to use as status for this program.
261 status=$?
262
263 #### Clean up test mail space.
264 #### cd to $MH_TEST_DIR before trying to remove its Mail
265 #### subdirectory. rm on Solaris won't remove it if it's in the
266 #### path of the current working directory.
267 test -z "$MH_TEST_NOCLEANUP" && (cd $MH_TEST_DIR; rm -rf "$MH_TEST_DIR"/Mail)
268
269 #### Report test name if set, which indicates failure.
270 #### Relies on set -e to invoke the trap which calls
271 #### this function on failure.
272 #### To use:
273 #### 1) Set test name before running the test, use start_test().
274 #### 2) Unset upon successful completion, use finish_test().
275 if test -n "$nmh_tests_testname"; then
276 echo $nmh_tests_testname failed
277 fi
278
279 #### Exit with non-zero status if failure. Failure is defined as either
280 #### non-empty nmh_tests_testname or non-zero exit status on entry to the
281 #### function.
282 if test -n "$nmh_tests_testname" -o $status -ne 0; then
283 test $status -ne 0 && exit $status || exit 1
284 test $status -ne 0 && exit 0 || exit 0
285 fi
286 }
287
288 #### Function to set the test name, and whatever the future brings.
289 start_test() {
290 nmh_tests_testname="$1"
291 }
292
293 #### Corresponding function to indicate that the test has finished. It need
294 #### not be called after each test, just the last one in a file.
295 finish_test() {
296 unset nmh_tests_testname
297 }
298
299 setup_test ()
300 {
301 set -e
302
303 MH="${MH_TEST_DIR}/Mail/.mh_profile"
304 MHMTSCONF="${MH_INST_DIR}${nmhetcdir}/mts.conf"
305 MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhlibexecdir}"
306 export MH MHMTSCONF MH_LIBEXEC_DIR
307
308 #
309 # Only install once
310 #
311 if [ -d "${MH_INST_DIR}${bindir}" ]; then
312 :
313 else
314 (cd "${MH_OBJ_DIR}" &&
315 make DESTDIR="${MH_INST_DIR}" SETGID_MAIL= install) ||
316 exit 1
317
318 #### Don't test with sendmail because it would really send the
319 #### mail. If configured to use sendmail, change to smtp instead
320 #### so that we use fakesmtp.
321 #### And set up the maildrop in the test directory so tests don't
322 #### use the user's real maildrop.
323 #### test-slocal needs to look at the original mts.conf, so save it.
324 mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
325 sed -e 's/mts: *.*/mts: smtp/' \
326 -e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
327 -e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
328 "${MHMTSCONF}.old" >"${MHMTSCONF}"
329 fi
330
331 #### On Solaris, must set PATH after the install!
332 PATH="${MH_INST_DIR}${bindir}:${PATH}"
333 export PATH
334
335 # clean old test data on exit
336 trap cleanup 0
337
338 # setup test data
339 mkdir -p "$MH_TEST_DIR/Mail" || exit 1
340 cat > "$MH" <<EOF || exit 1
341 Path: ${MH_TEST_DIR}/Mail
342 buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
343 fileproc: ${MH_INST_DIR}${bindir}/refile
344 libexecdir: ${MH_LIBEXEC_DIR}
345 mhbuild: -nocontentid
346 mhlproc: ${MH_LIBEXEC_DIR}/mhl
347 moreproc: cat
348 postproc: ${MH_LIBEXEC_DIR}/post
349 showmimeproc: ${MH_INST_DIR}${bindir}/mhshow
350 showproc: ${MH_LIBEXEC_DIR}/mhl
351 #: The following aren't currently used by the test suite, but are
352 #: defined here in case they are in the future:
353 mailproc: ${MH_INST_DIR}${bindir}/mhmail
354 rcvstoreproc: ${MH_LIBEXEC_DIR}/rcvstore
355 sendproc: ${MH_INST_DIR}${bindir}/send
356 whatnowproc: ${MH_INST_DIR}${bindir}/whatnow
357 whomproc: ${MH_INST_DIR}${bindir}/whom
358 #: incproc and packproc are defined in config.c but not used by any code.
359 EOF
360
361 if test -z '@nmhetcdirinst@'; then
362 #### This isn't used with make distcheck, so that we can use it to
363 #### be sure that etc files are not used from an existing nmh
364 #### installation.
365 #### posh doesn't like "${MH_INST_DIR}${nmhetcdir}"/*, so cd to
366 #### the directory and provide an argument without quotes to cp.
367 (cd "${MH_INST_DIR}${nmhetcdir}/" && cp * "${MH_TEST_DIR}/Mail")
368 fi
369
370 folder -create +inbox > /dev/null
371 # create 10 basic messages
372 for i in 1 2 3 4 5 6 7 8 9 10;
373 do
374 cat > $MH_TEST_DIR/Mail/inbox/$i <<EOF || exit 1
375 From: Test$i <test$i@example.com>
376 To: Some User <user@example.com>
377 Date: Fri, 29 Sep 2006 00:00:00
378 Message-Id: $i@test.nmh
379 Subject: Testing message $i
380
381 This is message number $i
382 EOF
383 done
384 }